---
title: DocumentTimeline
slug: Web/API/DocumentTimeline
tags:
  - API
  - Animation
  - AnimationTimeline
  - DocumentTimeline
  - Interface
  - Reference
  - Web Animations
  - waapi
  - web animations api
---
<p>{{ APIRef("Web Animations") }}{{ SeeCompatTable() }}</p>

<p>The <strong><code>DocumentTimeline</code></strong> interface of the <a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a> represents animation timelines, including the default document timeline (accessed via {{domxref("Document.timeline")}}).</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("DocumentTimeline.DocumentTimeline", "DocumentTimeline()")}}</dt>
 <dd>Creates a new <code>DocumentTimeline</code> object associated with the active document of the current browsing context.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>This interface inherits its property from its parent, {{domxref("AnimationTimeline")}}.</em></p>

<dl>
 <dt>{{domxref("AnimationTimeline.currentTime")}}</dt>
 <dd>Returns the time value in milliseconds for this timeline or <code>null</code> if it is inactive.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>We could share a single <code>documentTimeline</code> among multiple animations, thus allowing us to manipulate just that group of animations via their shared timeline. This bit of code would start all the cats animating 500 milliseconds into their animations:</p>

<pre class="brush: js notranslate">const cats = document.querySelectorAll('.sharedTimelineCat');
const sharedTimeline = new DocumentTimeline({ originTime: 500 });

for (const cat of cats) {
  const catKeyframes = new KeyframeEffect(cat, keyframes, timing);
  const catAnimation = new Animation(catKeyframes, sharedTimeline);
  catAnimation.play();
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Animations', '#the-documenttimeline-interface', 'DocumentTimeline' )}}</td>
   <td>{{Spec2('Web Animations')}}</td>
   <td>Editor's draft.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DocumentTimeline")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a></li>
 <li>{{domxref("AnimationTimeline")}}</li>
 <li>{{domxref("AnimationTimeline.currentTime")}}</li>
 <li>{{domxref("Document.timeline")}}</li>
 <li>{{domxref("DocumentTimeline.DocumentTimeline()")}}</li>
</ul>
